/*

  yyycpu - a virtual machine
  Copyright (C) 2000  Erik Thiele

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef __BINARYDEFS_HPP
#define __BINARYDEFS_HPP

#include <sys/types.h>

#define B0000 0
#define B0001 1
#define B0010 2
#define B0011 3
#define B0100 4
#define B0101 5
#define B0110 6
#define B0111 7
#define B1000 8
#define B1001 9
#define B1010 10
#define B1011 11
#define B1100 12
#define B1101 13
#define B1110 14
#define B1111 15

typedef   int64_t   int64;
typedef u_int64_t   uint64;
typedef   int32_t   int32;
typedef u_int32_t   uint32;
typedef   int16_t   int16;
typedef u_int16_t   uint16;
typedef   int8_t    int8;
typedef u_int8_t    uint8;

// 16 bit partition get commands
inline uint8 nib0(const uint16 value) { return value&15; };
inline uint8 nib1(const uint16 value) { return (value>>4)&15; };
inline uint8 nib2(const uint16 value) { return (value>>8)&15; };
inline uint8 nib3(const uint16 value) { return value>>12; };
inline uint8 byt0(const uint16 value) { return value&255; };
inline uint8 byt1(const uint16 value) { return value>>8; };

#endif
