/*

  yyycpu - a virtual machine
  Copyright (C) 2000  Erik Thiele

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef __LABELLIST_HPP
#define __LABELLIST_HPP

#include "../common/binarydefs.hpp"
#include "symbollist.hpp"

class labellist {
public:
  struct elem {
    inline elem(const symbollist::index_t symbolindex_, const uint32 address_, const bool defined_)
      : symbolindex(symbolindex_), address(address_), defined(defined_) {};
    symbollist::index_t symbolindex;
    uint32 address;
    bool defined;
  };

  typedef vector<elem>::size_type index_t;


  labellist ();
  labellist (const labellist &);
  labellist & operator= (const labellist &);
  ~labellist ();

  index_t findoraddundefined (const symbollist::index_t symbolindex);
  void defineoradd (const symbollist::index_t symbolindex, const uint32 address);
  void cut(const uint32 address, const uint32 count);
  inline elem & get (const index_t labelindex) { return vec[labelindex]; };

  void assertalldefined() const; // throws error if undefined labels exist.
  void debugprint ();

private:
  vector<elem> vec;
};

#endif
