/*

  yyycpu - a virtual machine
  Copyright (C) 2000  Erik Thiele

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef __DISASSEMBLE_HPP
#define __DISASSEMBLE_HPP

#include "../common/membunch.hpp"

#include <string>

enum mode_show_t {MODE_SHOW_UNSIGNEDDEC, MODE_SHOW_SIGNEDDEC, MODE_SHOW_HEX};
extern mode_show_t mode_show;
enum mode_address_t {MODE_ADDRESS_HEX, MODE_ADDRESS_DEC};
extern mode_address_t mode_address;
extern bool mode_info_showunsigneddec;
extern bool mode_info_showsigneddec;
extern bool mode_info_showhex;
extern bool mode_info_showdist;
extern bool mode_codeaddress;

extern membunch *disas_membunch;
extern uint32 disas_addr;
extern bool disas_lastwasillegal;
const string disassemble (); // increments disas_addr correctly

#endif
